# Transmission blocklist downloader

Download and set up multiple blocklists for your Transmission BitTorrent client in a simple way (Linux)

## Disclaimer

Author of this repository is not responsible for any possible illegal or malicious usage of any files provided in this repository by anyone. The repository is provided as an act of good will and does not intend to encourage users to participate in any illegal activities.

## Requirements

- Unix-based OS (Linux tested)

- Bash shell 4.0 or above

- Internet connection

- Transmission client

- The following executables must be found on your system:

    - transmission-cli
    - gzip
    - unzip
    - bash
    - wget 
    - date
    - find
    - kill
    - awk
    - sed
    - grep
    - ping
    - mv
    - wc
    
- Recommended: Transmission GTK or Transmission Qt

## Installation

Just grab the script. On your shell view, run

```
wget https://github.com/Fincer/transmission-blocklist-downloader/blob/master/transmission-blocklists.sh

```

Then add your blocklists as instructed [below](https://github.com/Fincer/transmission-blocklist-downloader#q-how-do-i-add-more-blocklists).

## Usage

On your bash shell, run

```
bash transmission_blocklists.sh
```

or

```
bash transmission_blocklists.sh -y
```

where -y parameter passes all Yes/No questions with auto-yes answer (except for internet connection test)

## Configuration

### Q: How do I add more blocklists?

**A:** The provided script has array BLOCKLISTS where your blocklists should be placed in. Adding new lists is very simple. The list syntax is as follows

```
[list_1-friendly-name]="list_1_URL"
[list_2-friendly-name]="list_2_URL"
...
```

where 

- 'list_X-friendly-name' is human-readable name you give to the blocklist. This is for easier management for massive amount of blocklists you may have.

- 'list_X_URL' is the corresponding URL address of your blocklist, points to zip or gz archive.

Take a look into the script for more examples.

-----------------------

### Q: In which format the blocklists should be added?

**A:** The script supports only zip and gz archive formats.

Required Transmission .bin blocklist files are generated by 'transmission-cli' executable.

-----------------------

### Q: When I delete a blocklist, does it get deleted from my Transmission client as well?

**A:** Yes, the script deletes blocklists you've removed from BLOCKLISTS array. However, I recommend you to close your Transmission client and then running the script (after blocklist deletion).

-----------------------

### Q: I have added an unavailable blocklist. How does the script handle this blocklist?

**A:** The script finds out that the blocklist is not available anymore, warns you about it and asks you whether to continue downloading other blocklists.

-----------------------

### Script configuration parameters

- **UPDATELIMIT_DAYS** = Older blocklist files than this should be updated
    - Default value: 15
    - Value in days

- **WGET_TIMEOUT** = Time out after which downloading a blocklist will be ignored
    - Default value: 30
    - Value in seconds
    
- **TRANSMISSION_BLOCKLISTDIR** = Default blocklist directory path of Transmission client program
    - Default value: $HOME/.config/transmission/blocklists/
    
- **TEST_PROVIDER** = The script checks your internet connection by pinging this URL address
    - Default value: www.github.com

## License

This repository uses GPLv3 license. Please see [LICENSE](https://github.com/Fincer/transmission-blocklist-downloader/blob/master/LICENSE) for details.
